var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteralLoose(['\n      query Schema($url: String!) {\n        schema(url: $url)\n      }\n    '], ['\n      query Schema($url: String!) {\n        schema(url: $url)\n      }\n    ']),
    _templateObject2 = _taggedTemplateLiteralLoose(['\n      query Query($url: String!, $query: String!) {\n        query(url: $url, query: $query)\n      }\n    '], ['\n      query Query($url: String!, $query: String!) {\n        query(url: $url, query: $query)\n      }\n    ']),
    _templateObject3 = _taggedTemplateLiteralLoose(['\n      mutation Mutation($url: String!, $mutation: String!) {\n        mutate(url: $url, mutation: $mutation)\n      }\n    '], ['\n      mutation Mutation($url: String!, $mutation: String!) {\n        mutate(url: $url, mutation: $mutation)\n      }\n    ']);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteralLoose(strings, raw) { strings.raw = raw; return strings; }

import React, { Component } from 'react';
import gql from 'graphql-tag';
import { graphql, compose } from 'react-apollo';
import { buildClientSchema } from 'graphql';

/**
 * TODO docs
 *
 * @private
 */
var withSchema = function withSchema(url) {
  return graphql(gql(_templateObject), {
    name: 'schema',
    options: { variables: { url: url } }
  });
};

/**
 * TODO docs
 *
 * @private
 */
var withQuery = function withQuery(url, query) {
  return graphql(gql(_templateObject2), {
    name: 'query',
    options: {
      variables: {
        url: url,
        query: query
      }
    }
  });
};

/**
 * TODO docs
 *
 * @private
 */
var withMutation = function withMutation(url, mutation) {
  return graphql(gql(_templateObject3), {
    name: 'mutation',
    options: {
      variables: {
        url: url,
        mutation: mutation
      }
    }
  });
};

/**
 * TODO docs
 *
 * @private
 */
var withProps = function withProps(props) {
  return function (WC) {
    return function (newProps) {
      return React.createElement(WC, _extends({}, newProps, props));
    };
  };
};

/**
 * TODO docs
 *
 * @private
 */
var withOperation = function withOperation(url, action) {
  return isMutation(action) ? withMutation(url, action) : withQuery(url, action);
};

/**
 * TODO docs and do more
 *
 * @private
 */
var getOperation = function getOperation(action) {
  return gql(action).definitions[0].operation;
};

/**
 * TODO docs and do more
 *
 * @private
 */
var isMutation = function isMutation(action) {
  return getOperation(action) === 'mutation';
};

/**
 * TODO docs and pluralize
 *
 * @private
 */
var getField = function getField(action, schema) {
  return buildClientSchema(JSON.parse(schema))[isMutation(action) ? 'getMutationType' : 'getQueryType']().getFields()[getName(action)];
};

/**
 * TODO docs and do
 *
 * @private
 */
var getType = function getType(action, schema) {
  var field = getField(action, schema);
  return field && field.type;
};

/**
 * TODO docs and more
 *
 * @private
 */
var getName = function getName(action) {
  return gql(action).definitions[0].selectionSet.selections[0].name.value;
};

/**
 * TODO docs
 *
 * @private
 */
var withTidy = function withTidy(WC) {
  return function (_ref) {
    var query = _ref.query,
        mutate = _ref.mutate,
        schema = _ref.schema,
        loading = _ref.loading,
        error = _ref.error,
        props = _objectWithoutProperties(_ref, ['query', 'mutate', 'schema', 'loading', 'error']);

    return React.createElement(WC, _extends({}, props, {
      query: query && query.query,
      schema: schema && schema.schema,
      loading: loading || query && query.loading || schema && schema.loading,
      error: error || query && query.error || schema && schema.error
    }));
  };
};

/**
 * TODO docs
 *
 * @private
 */
var withMutationHandler = function withMutationHandler(WC) {
  return (
    /**
     * TODO docs
     *
     * @extends Component
     *
     * @private
     */
    function (_Component) {
      _inherits(MutationHandler, _Component);

      function MutationHandler() {
        var _temp, _this, _ret;

        _classCallCheck(this, MutationHandler);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
      }

      /**
       * TODO docs
       *
       * @private
       */
      MutationHandler.prototype.componentDidMount = function componentDidMount() {
        var _this2 = this;

        var _props = this.props,
            mutation = _props.mutation,
            onError = _props.onError;

        mutation().then(function (_ref2) {
          var mutate = _ref2.data.mutate;
          return _this2.setState({ mutate: mutate });
        }).catch(function (error) {
          return _this2.setState({ error: error });
        });
      };

      /**
       * TODO docs
       *
       * @private
       */


      MutationHandler.prototype.render = function render() {
        var _state = this.state,
            mutate = _state.mutate,
            error = _state.error;

        return React.createElement(WC, _extends({}, this.props, {
          loading: !mutate && !error || this.props.loading,
          mutate: mutate,
          error: error
        }));
      };

      return MutationHandler;
    }(Component)
  );
};

/**
 * TODO docs
 *
 * @private
 */
var withDataHandler = function withDataHandler(WC) {
  return function (_Component2) {
    _inherits(DataHandler, _Component2);

    function DataHandler(props) {
      _classCallCheck(this, DataHandler);

      var _this3 = _possibleConstructorReturn(this, _Component2.call(this, props));

      var query = props.query,
          mutate = props.mutate,
          action = props.action,
          schema = props.schema,
          error = props.error;

      var raw = query || mutate;
      var name = getName(action);
      var type = getType(action, schema);
      _this3.state = {
        data: raw && JSON.parse(raw)[name],
        name: name,
        type: type,
        error: !type && { message: 'Action not found: ' + name } || error
      };
      return _this3;
    }

    DataHandler.prototype.componentDidMount = function componentDidMount() {
      var _props2 = this.props,
          onError = _props2.onError,
          onLoad = _props2.onLoad;
      var _state2 = this.state,
          error = _state2.error,
          data = _state2.data;

      if (error) {
        onError(error);
      } else {
        onLoad(data);
      }
    };

    DataHandler.prototype.render = function render() {
      return React.createElement(WC, _extends({}, this.props, this.state));
    };

    return DataHandler;
  }(Component);
};

/**
 * TODO docs
 *
 * @private
 */
var withLoadingHandler = function withLoadingHandler(WC) {
  return function (props) {
    var loading = props.loading,
        renderLoading = props.renderLoading;

    return loading ? renderLoading() : React.createElement(WC, props);
  };
};

/**
 * TODO docs
 *
 * @private
 */
var withErrorHandler = function withErrorHandler(WC) {
  return function (props) {
    var error = props.error,
        renderError = props.renderError;

    return error ? renderError(error) : React.createElement(WC, props);
  };
};

/**
 * TODO docs
 *
 * @private
 */
var withHandlers = function withHandlers(isMutation) {
  return compose(isMutation ? withMutationHandler : function (_) {
    return _;
  }, withLoadingHandler, withDataHandler, withErrorHandler);
};

/**
 * TODO docs
 *
 * @private
 */
var withDefaults = withProps({
  renderLoading: function renderLoading() {
    return React.createElement(
      'div',
      null,
      'loading...'
    );
  },
  renderError: function renderError(e) {
    return React.createElement(
      'div',
      null,
      e.message || 'Something went wrong'
    );
  },
  onError: function onError() {},
  onLoad: function onLoad() {}
});

/**
 * TODO docs
 */
export var withAction = function withAction(props) {
  var url = props.url,
      action = props.action;

  return compose(withDefaults, withProps(props), withSchema(url), withOperation(url, action), withTidy, withHandlers(isMutation(action)));
};

/**
 * Return component outputting the response of the GraphQL action.
 *
 * @param {Object} props - The component props.
 * @param {string} props.url - The GraphQL api endpoint.
 * @param {string} props.action - The GraphQL action.
 * @param {GraphQLSchema} [props.schema] - The schema for the GraphQL api.
 * @param {Action~onChange} [props.onChange] - The data change handler.
 * @param {ApolloClient} props.client - The Apollo client.
 * @returns {Component} A component that displays the response from the action.
 *
 * @example <caption>Display users' names from GraphQL API</caption>
 * <ProxyProvider>
 *   <Action
 *     url="http://proxy-graphql.herokuapp.com"
 *     action="query Q { test }"
 *   >
 *     <Put />
 *   </Action>
 * </ProxyProvider>
 */
export var Action = function Action(props) {
  var _ = withAction(props)(function (newProps) {
    return React.cloneElement(props.children, _extends({}, newProps));
  });
  return React.createElement(_, null);
};
/**
 * This callback handles Action change events.
 *
 * @callback Action~onChange
 * @param {*} value
 */